package servlets;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import clases.*;

/**
 * Servlet implementation class SieteCartas
 */
@WebServlet("/SieteCartas")
public class SieteCartas extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public SieteCartas() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Poker p = new Poker();
		Carta [] cartas;
		
		//Genera las cartas aleatoriamente y las almacena en un array de Cartas
		cartas = p.generarCartas(7);
		
		String mejores = p.mejorJugada(cartas);
		
		request.setAttribute("cartas", cartas);
		request.setAttribute("mejores", mejores);
		
		/*
		//Imprime las cartas generadas aleatoriamente
		for(int i=0 ;i<cartas.length; i++) {
			System.out.println(cartas[i].valor+cartas[i].palo);
		}		
		System.out.println("******");
		
		//Encuentra las mejores jugadas de todas las combinaciones posibles de 7 cartas tomadas de a 5
		//y las guarda en un string llamado mejores
		
		
		System.out.println(mejores);
		System.out.println("******");
		*/
		
		//Se define un array de cartas para almacenar la mano que será evaluada
		//y de quien se obtendrá el nombre de jugada
		Carta[] mano = new Carta[5];
		
		//Separa el string en arrays, donde encuentre ";"
		//Si hay ; quiere decir que hubieron dos o mas ganadores
		for(int i=0; i<mejores.split(";").length; i++) {
			//Los arrays resultantes de separar por ; lo separa por coma
			for(int j=0; j<mejores.split(";")[i].split(",").length; j++) {
				mano[j] = new Carta(mejores.split(";")[i].split(",")[j]);
				System.out.println(mano[j].valor+mano[j].palo);
			}
			System.out.println(p.nombreJugada(mano));
			System.out.println("************");
		}		
		
		
		RequestDispatcher rd = getServletContext().getRequestDispatcher("/WEB-INF/jsp/SieteCartas.jsp");		
		rd.forward(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
	}

}
